• Codeforces Round #240 (Div. 2)(A -- D)


    点我看题目

    A. Mashmokh and Lights

    time limit per test:1 second
    memory limit per test:256 megabytes
    input:standard input
    output:standard output

    Mashmokh works in a factory. At the end of each day he must turn off all of the lights.

    The lights on the factory are indexed from 1 to n. There are n buttons in Mashmokh's room indexed from 1 to n as well. If Mashmokh pushes button with index i, then each light with index not less than i that is still turned on turns off.

    Mashmokh is not very clever. So instead of pushing the first button he pushes some of the buttons randomly each night. He pushed mdistinct buttons b1, b2, ..., bm (the buttons were pushed consecutively in the given order) this night. Now he wants to know for each light the index of the button that turned this light off. Please note that the index of button bi is actually bi, not i.

    Please, help Mashmokh, print these indices.

    Input

    The first line of the input contains two space-separated integers n and m (1 ≤ n, m ≤ 100), the number of the factory lights and the pushed buttons respectively. The next line contains m distinct space-separated integers b1, b2, ..., bm (1 ≤ bi ≤ n).

    It is guaranteed that all lights will be turned off after pushing all buttons.

    Output

    Output n space-separated integers where the i-th number is index of the button that turns the i-th light off.

    题意 : 如果按下一个开关,所有编号比这个开关的编号大的灯都会被关掉,让你输出n盏灯分别是被那个开关关上的。

    思路 :也算是一个小标记吧。

     1 #include <iostream>
     2 #include <stdio.h>
     3 #include <string.h>
     4 #include <stdlib.h>
     5 #include <map>
     6 
     7 using namespace std ;
     8 
     9 int b[1100] ;
    10 int a[1100] ;
    11 int main()
    12 {
    13     int n,m ;
    14     while (~scanf("%d %d",&n,&m))
    15     {
    16         for(int i = 1 ; i <= m ; i++)
    17             scanf("%d",&b[i]) ;
    18             memset(a,0,sizeof(a)) ;
    19         for(int i = 1 ; i <= m ; i++)
    20         {
    21             for(int j = b[i] ; j <= n ; j++)
    22             {
    23                 if(a[j] == 0)
    24                 a[j] = b[i] ;
    25             }
    26         }
    27         for(int i = 1 ; i < n ; i++)
    28             printf("%d ",a[i]) ;
    29         printf("%d
    ",a[n]) ;
    30     }
    31     return 0 ;
    32 }
    View Code

    B. Mashmokh and Tokens

    time limit per test:1 second
    memory limit per test:256 megabytes
    input:standard input
    output:standard output

    Bimokh is Mashmokh's boss. For the following n days he decided to pay to his workers in a new way. At the beginning of each day he will give each worker a certain amount of tokens. Then at the end of each day each worker can give some of his tokens back to get a certain amount of money. The worker can save the rest of tokens but he can't use it in any other day to get more money. If a worker gives backw tokens then he'll get  dollars.

    Mashmokh likes the tokens however he likes money more. That's why he wants to save as many tokens as possible so that the amount of money he gets is maximal possible each day. He has n numbers x1, x2, ..., xn. Number xi is the number of tokens given to each worker on the i-th day. Help him calculate for each of n days the number of tokens he can save.

    Input

    The first line of input contains three space-separated integers n, a, b (1 ≤ n ≤ 105; 1 ≤ a, b ≤ 109). The second line of input containsn space-separated integers x1, x2, ..., xn (1 ≤ xi ≤ 109).

    Output

    Output n space-separated integers. The i-th of them is the number of tokens Mashmokh can save on the i-th day.

    Sample test(s)
    input
    5 1 4
    12 6 11 9 1
    output
    0 2 3 1 1 
    input
    3 1 2
    1 2 3
    output
    1 0 1 
    input
    1 1 1
    1
    output
    0

    题意:如果一个人有w张票,那他会得到w*a/b取整个钱,现在让你在保证得到的钱数不变的情况下能够省得最多的票是多少。
    思路 : 我一开始是这么想的,如果有4张票,a是3,b是7,那就是取余一下,3*4%7得到的就是省下来的,真是脑子崩溃了啊,3*4得到12这个数而非12张票,所以怎么可能我只有4张票却能够省掉5张呢?我真是让自己佩服死了,脑子居然没转转。所以就是要保证能够得到1个钱的情况下,让4减小,如果变为3,则还能得到一个钱,但是如果变为2就会变为0个钱了,所以只要找出那个满足这个式子的最大值,然后4减去这个最大值就行了。
     1 #include <stdio.h>
     2 #include <string.h>
     3 #include <iostream>
     4 
     5 using namespace std ;
     6 
     7 long long aa[100100] ;
     8 int main()
     9 {
    10     long long n,a,b  ;
    11     while(cin>>n>>a>>b)
    12     {
    13         for(int i = 1 ; i <= n ; i++)
    14             cin>>aa[i] ;
    15         for(int i = 1 ; i <= n ; i++)
    16             cout<<aa[i]*a%b/a<<" " ;
    17         cout<<endl ;
    18     }
    19     return 0 ;
    20 }
    View Code

    C. Mashmokh and Numbers

    time limit per test:1 second
    memory limit per test:256 megabytes
    input:standard input
    output:standard output

    It's holiday. Mashmokh and his boss, Bimokh, are playing a game invented by Mashmokh.

    In this game Mashmokh writes sequence of n distinct integers on the board. Then Bimokh makes several (possibly zero) moves. On the first move he removes the first and the second integer from from the board, on the second move he removes the first and the second integer of the remaining sequence from the board, and so on. Bimokh stops when the board contains less than two numbers. When Bimokh removes numbers x and y from the board, he gets gcd(x, y) points. At the beginning of the game Bimokh has zero points.

    Mashmokh wants to win in the game. For this reason he wants his boss to get exactly k points in total. But the guy doesn't know how choose the initial sequence in the right way.

    Please, help him. Find n distinct integers a1, a2, ..., an such that his boss will score exactly k points. Also Mashmokh can't memorize too huge numbers. Therefore each of these integers must be at most 109.

    Input

    The first line of input contains two space-separated integers n, k (1 ≤ n ≤ 105; 0 ≤ k ≤ 108).

    Output

    If such sequence doesn't exist output -1 otherwise output n distinct space-separated integers a1, a2, ..., an (1 ≤ ai ≤ 109).

    Sample test(s)
    input
    5 2
    output
    1 2 3 4 5
    input
    5 3
    output
    2 4 3 7 1
    input
    7 2
    output
    -1
    Note

    gcd(x, y) is greatest common divisor of x and y.

    题意 : 给你n和k,让你找出n个完全不一样的数,要求gcd(a1,a2)+gcd(a3,a4)+.....+gcd(an-1,an) = k。如果n是奇数则最后那个数就不用算了就是要满足gcd(a1,a2)+....+gcd(an-2,an-1) = k。

    思路 : 比赛的时候已经让B题搞透支了,所以一时都没想到这其实也是一道水题啊!!!你只要把第一组的那个最大公约数求出来,然后让后边的全都互质不就行了。

     1 #include <stdio.h>
     2 #include <string.h>
     3 
     4 using namespace std ;
     5 
     6 int main()
     7 {
     8     int n , k;
     9     while(~scanf("%d %d",&n,&k))
    10     {
    11         if(k < n/2 || (n < 2 && k != 0))
    12         {
    13             printf("-1
    ") ;
    14             continue ;
    15         }
    16         else if(k == n/2)
    17         {
    18             for(int i = 1 ; i < n ; i++)
    19                 printf("%d ",i) ;
    20             printf("%d
    ",n) ;
    21         }
    22         else
    23         {
    24             int flag[21] ;
    25             memset(flag,0,sizeof(flag));
    26             int x = k-n/2+1 ;
    27             printf("%d %d ",x,x*2) ;
    28             for(int i = x*2+1 ; i <= x*2+n-2 ; i++)
    29                 printf("%d ",i) ;
    30             puts("") ;
    31         }
    32     }
    33     return 0 ;
    34 }
    View Code

    D. Mashmokh and ACM

    time limit per test:1 second
    memory limit per test:256 megabytes
    input:standard input
    output:standard output

    Mashmokh's boss, Bimokh, didn't like Mashmokh. So he fired him. Mashmokh decided to go to university and participate in ACM instead of finding a new job. He wants to become a member of Bamokh's team. In order to join he was given some programming tasks and one week to solve them. Mashmokh is not a very experienced programmer. Actually he is not a programmer at all. So he wasn't able to solve them. That's why he asked you to help him with these tasks. One of these tasks is the following.

    A sequence of l integers b1, b2, ..., bl (1 ≤ b1 ≤ b2 ≤ ... ≤ bl ≤ n) is called good if each number divides (without a remainder) by the next number in the sequence. More formally  for all i (1 ≤ i ≤ l - 1).

    Given n and k find the number of good sequences of length k. As the answer can be rather large print it modulo 1000000007 (109 + 7).

    Input

    The first line of input contains two space-separated integers n, k (1 ≤ n, k ≤ 2000).

    Output

    Output a single integer — the number of good sequences of length k modulo 1000000007 (109 + 7).

    Sample test(s)
    input
    3 2
    output
    5
    input
    6 4
    output
    39
    input
    2 1
    output
    2
    Note

    In the first sample the good sequences are: [1, 1], [2, 2], [3, 3], [1, 2], [1, 3].

    题意 : 给你两个数n和k,让你找满足一下条件的数列个数,数列里的所有数大小都不超过n,数列长度为k,数列的每后一个数都是前一个数的整数倍。

    思路 : DP。比赛的时候压根儿都没看这个题,比完了补得题。因为后一个是前一个的倍数,所以我们说每一个状态都只跟前一个状态有关。dp[i][j]代表的以 i 为结尾长度为j的数列的个数,也就是说,指的是第j为是 i 的数列个数。

    dp[p][j + 1] = dp[p][j + 1] + dp[i][j];(p是i的整数倍)
     1 #include <stdio.h>
     2 #include <string.h>
     3 
     4 using namespace std ;
     5 
     6 const int maxn = 2012 ;
     7 const int MOD = 1000000007 ;
     8 
     9 int dp[maxn][maxn] ;
    10 
    11 int main()
    12 {
    13     int n,k ;
    14     while(~scanf("%d %d",&n,&k))
    15     {
    16         int num = 0 ;
    17         for(int i = 1 ; i < maxn ; i++)
    18             dp[i][1] = 1;
    19         for(int j = 1 ; j < k ; j++)
    20         {
    21             for(int i = 1 ; i <= n ; i ++)
    22             {
    23                 for(int h = i ; h <= n ; h += i)
    24                 {
    25                     dp[h][j+1] = (dp[h][j+1]+dp[i][j])%MOD ;
    26                 }
    27             }
    28         }
    29         for(int i = 1 ; i <= n ; i++)
    30         {
    31             num += dp[i][k] ;
    32             num %= MOD ;
    33         }
    34         printf("%d
    ",num) ;
    35     }
    36     return 0 ;
    37 }
    View Code
  • 相关阅读:
    JAVA第一次上机作业
    如何设置FreePBX的数据库用户可以通过远程来连接Mysql数据库?
    Mysql 用户root密码重置
    使用FreePBX和第三方线路对接
    防御攻击
    Xshell配置公钥,免密码登陆
    centos7防火墙启动关闭
    Windows执行bat脚本乱码
    Windows开机执行bat脚本
    bat脚本之启动MySQL服务
  • 原文地址:https://www.cnblogs.com/luyingfeng/p/3650272.html
Copyright © 2020-2023  润新知